unit PrintScreen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TTipo = (Simples, Invertida);

  TPrintScreen = class(TComponent)
  private
    Ftipo: TTipo;
    procedure SetTipo(Value: TTipo);
  protected
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure PrintScr(Image: TBitmap);
  published
    property Copia: TTipo read FTipo write SetTipo default Simples;
  end;

procedure Register;

implementation

constructor TPrintScreen.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FTipo:= Simples;
end;

destructor TPrintScreen.Destroy;
begin
  inherited Destroy;
end;

procedure TPrintScreen.SetTipo(Value: TTipo);
begin
  try
    FTipo:= Value;
  except
    FTipo:= Simples;
  end;
end;

procedure TPrintScreen.PrintScr(Image: TBitmap);
var
  DC: HDC;
begin
  DC:= GetDC(GetDesktopWindow);
  try
    Image.Width:= GetDeviceCaps(DC, HorzRes);
    Image.Height:= GetDeviceCaps(DC, VertRes);
    if FTipo = Simples then BitBlt(Image.Canvas.Handle, 0, 0, Image.Width, Image.Height, DC, 0, 0, SRCCOPY);
    if FTipo = Invertida then BitBlt(Image.Canvas.Handle, 0, 0, Image.Width, Image.Height, DC, 0, 0, SRCINVERT);
  finally
    ReleaseDC(GetDesktopWindow, DC);
  end;
end;

procedure Register;
begin
  RegisterComponents('Delphi Center', [TPrintScreen]);
end;

end.
 